<?php
/* #############################################
	Fonctions de Calul
###############################################
Les fonctions de calcul sont l pour enregistrer toutes les donnes qui peuvent tre affiches.
Les fonctions de calcul commencent toutes par 'get' .
Un fonction de calcul ne peut lancer que des fonctions de calcul.
###############################################
Les fonctions prsentent dans ce fichier sont :
getUrlVerifiee
getUrlNom
getLargeurImageReelle
getHauteurImageReelle
getPoidsImageReelle
getDimenssionsImageReduite
getHauteurImageReduite
getLargeurImageReduite
getAlbumDonneesAffichage
getAlbumImages
getMenuArbo
getMenuDossiers
getCSSPage
############################################# */


/* #############################################
	getUrlVerifiee
###############################################
 getUrlVerifiee reoit en paramtre une Url
 Elle renvoie une chane vide, si celle-ci contient 2 points.
 Autrement elle renvoit l'url normale.

 Merci  symptOme de la team GSH pour la dtection de la faille.
 ############################################## */
function getUrlVerifiee($url) {
	$carac='ok';
	$urltest=eregi_replace('/','',$url);
	if(ereg("\.\.", $urltest)){
		$carac='pas_ok';
	}
	if($urltest=='' || $carac!='ok'){
		$url='';
	}
	
	return $url;
}



/* #############################################
	getUrlNom
###############################################
 getUrlNom prend en paramtre une url
 Elle renvoie le nom du dernier dossier de l'arborescence.
############################################# */
function getUrlNom($url) {
	/* ### On supprime le dernier slash et on affiche le lien ### */
	$url = substr($url, 0, -1);
	$nom = substr($url, strrpos($url,"/")+1 );
	
	return $nom;
}



/* #############################################
	getLargeurImageReelle
###############################################
rcupre la largeur d'une image donne en paramtre
############################################# */
function getLargeurImageReelle($imageSource) {
	$sizeimgo = getimagesize($imageSource);
	return $sizeimgo[0];
}


			
/* #############################################
	getHauteurImageReelle
###############################################
rcupre la hauteur d'une image donne en paramtre
############################################# */
function getHauteurImageReelle($imageSource) {
	$sizeimgo = getimagesize($imageSource);
	return $sizeimgo[1];
}



/* #############################################
	getPoidsImageReelle
###############################################
rcupre le poids d'une image donne en paramtre
############################################# */
function getPoidsImageReelle($imageSource) {
	$poids = filesize($imageSource);
	$poids = round ($poids/1024);
	return $poids;
}



/* #############################################
	getDimenssionsImageReduite
###############################################
rcupre les dimenssions de l'image relle donne en paramtres.
Calcul en fonction de la personalisation, les dimenssions de l'image rduite.
############################################# */
function getDimenssionsImageReduite($imageSource, $perso) {
	$largeur = getLargeurImageReelle($imageSource);
	$hauteur = getHauteurImageReelle($imageSource);
	$echange = 0;
	if ($largeur > $hauteur) {
		$echange = $largeur;
		$largeur = $hauteur;
		$hauteur = $echange;
	}
	if ($largeur > $perso['largeurImage']) {
		$hauteur = round($hauteur * $perso['largeurImage'] / $largeur);
		$largeur = $perso['largeurImage'];
	}
	if ($hauteur > $perso['hauteurImage']) {
		$largeur = round($largeur * $perso['hauteurImage'] / $hauteur);
		$hauteur = $perso['hauteurImage'];
	}
	if ($echange != 0) {
		$echange = $largeur;
		$largeur = $hauteur;
		$hauteur = $echange;
	}
	$dimenssions[0] = $largeur;
	$dimenssions[1] = $hauteur;

	return $dimenssions;
}


			
/* #############################################
	getHauteurImageReduite
###############################################
Rcupre la hauteur de l'image rduite
############################################# */
function getHauteurImageReduite($imageSource, $perso) {
	$dimenssions = getDimenssionsImageReduite($imageSource, $perso);
	return $dimenssions[1];
}


			
/* #############################################
	getLargeurImageReduite
###############################################
Rcupre la largeur de l'image rduite
############################################# */
function getLargeurImageReduite($imageSource, $perso) {
	$dimenssions = getDimenssionsImageReduite($imageSource, $perso);
	return $dimenssions[0];
}


	
/* #############################################
	getAlbumDonneesAffichage
###############################################
 getAlbumDonneesAffichage lance la fonction getAlbumImages.
 recherche toutes les informations ncessaires  l'affichage des ces images :
 le numro de page,
 le nombre de page,
 le nombre d'images  afficher,
 le nombre de lignes  afficher,
 les images  afficher.
############################################# */
function getAlbumDonneesAffichage($urlt, $perso, $page) {
	$affichage['menuActif'] = getUrlNom($urlt);
	$images = getAlbumImages($urlt);
	
	$nbImagesTotal = count($images);
	$nbImagesParPage = $perso['nbLignes'] * $perso['nbColonnes'];
	$affichage['page'] = $page;
	$affichage['nbPage'] = ceil($nbImagesTotal / $nbImagesParPage);
	$imageDebut = ($page-1)*$nbImagesParPage;
	if ($imageDebut > $nbImagesTotal) $imageDebut = $nbImagesTotal;
	$imageFin = ($page * $nbImagesParPage)-1;
	if ($imageFin >= $nbImagesTotal) $imageFin = $nbImagesTotal - 1;
	$affichage['nbImagesAAfficher'] = $imageFin - $imageDebut + 1;
	$affichage['nbLignesAAfficher'] = ceil($affichage['nbImagesAAfficher'] / $perso['nbColonnes']);
	$affichage['images'] = array_slice($images, $imageDebut, $affichage['nbImagesAAfficher']);
	
	return $affichage;
}



/* #############################################
	getAlbumImages
###############################################
getAlbumImages ouvre le dossier courant.
recherche tous les fichier images (JPG, GIF, PNG).
enregistre le nom des images valides contenu dans ce dossier dans un tableau.
trie alphabtiquement ce tableau, et le renvoie.
############################################# */
function getAlbumImages($urlt) {
	$dossier = opendir($urlt);
	$images = array();
	while($fichier = readdir($dossier)){
		$extent=substr($fichier,strrpos($fichier,"."));
		$extensaj=strtoupper($extent); 
		if($extensaj=='.JPG' || $extensaj=='.JPEG' || $extensaj=='.GIF' || $extensaj=='.PNG'){
			array_push($images, $fichier);
		}
		$extensaj='';
	}
	closedir($dossier);
	sort($images);
	
	return ($images);
}



/* #############################################
	getMenuArbo
###############################################
getMenuArbo utilise la fonction getMenuDossiers
Elle cre l'arborescence complte des dossiers par rcursivit.
############################################# */
function getMenuArbo($url) {
	$arbo['nom'] = getMenuDossiers($url);
	$arbo['taille'] = count($arbo['nom']);
	for($i=0; $i<count($arbo['nom']); $i++) {
		$nom = $arbo['nom'][$i];
		$arbo['lien'][$i] = $url.'/'.$nom;
		$arbo['fils'][$i] = getMenuArbo($arbo['lien'][$i]);
		$arbo['taille'] = $arbo['taille'] + $arbo['fils'][$i]['taille'];
	}
	
	return $arbo;
	
}



/* #############################################
	getMenuDossiers
###############################################
getMenuDossiers ouvre le dossier donn en url, recherche tous les sous dossiers.
et renvoie un tableau avec le nom des dossiers.
############################################# */	
function getMenuDossiers($url) {
	// Initialisation des variables dossiers
	if($url!='') {
		$urlmemo=$url.'/';
	}
	else{
		$url='.';
		$urlmemo='';
	}
	$dossiers = array();

	// Recherche des dossiers
	if ($handle = opendir($url)) {
	    while (($fichier = readdir($handle)) !== false) {
	        if ((is_dir($urlmemo.$fichier)) && $fichier != "." && $fichier != "..") {
				array_push($dossiers, $fichier);
	        }
	    }
	    closedir($handle);
	}
	
	// Tri alphabtique des dossiers
	sort($dossiers);
	
	return $dossiers;
}



/* #############################################
	getCssPage
###############################################
getCssPage calcul le CSS d'une page d'album
En fonction de la personalisation et des calculs dj effectus.
############################################# */
function getCssPage($persoCss, $perso, $nbMenu, $nbLignes) {
	$hauteurImage = max($perso['hauteurImage'], $perso['largeurImage']);
	$hauteurMenu = $nbMenu*20 + 10;
	$hauteurAlbum = $nbLignes*$hauteurImage + 40;
	$hauteurTable = max($hauteurMenu, $hauteurAlbum);
	
	$css ="
		#entete {
			padding-top:			10px;
			padding-bottom:			30px;
			text-align:				center;
			font-size:				30px;
		}
		body {
			font-family : 			Arial;
			font-size :				medium;
			background-color :		#".$persoCss['couleurFond'].";
			padding-top:			20px;
			color:					#".$persoCss['couleurEcriture'].";
		}
		#entete,
		#menu,
		#credits,
		#images,
		#images table.images td {
			background-color :		#".$persoCss['couleurTable'].";
		}
		#menu,
		#images {
			height:					".$hauteurTable.";			
		}
		#menu {
			width : 				".$persoCss['largeurMenu'].";
			float :					left;
			text-align:				left;
			padding-top:			10px;
		}
		#menu table {
			padding-left:			10px;
			font-size :				small;
		}
		#menu table td.dossier {
			height:					20px;
			background-color :		#".$persoCss['couleurMenu'].";
			text-align: 			left;
		}
		#images {
			margin-left:			".$persoCss['largeurMenu'].";
			text-align:				center;		
		}
		#images table {
			margin:					auto;
			width:					100%;
		}
		#images table.images tr{
			height:					".$hauteurImage.";
		}
		#images #menuHorizontal {
			padding-top:			10px;
			height:					30px;
			text-align:				center;
		}
		#images table.images {
			font-size:				x-small;
		}
		#credits {
			padding-top:			20px;
			padding-bottom:			20px;
			text-align:				center;
		}
		img {
			border:					".$persoCss['epaisseurCadreImage']."px #".$persoCss['couleurCadreImage']." solid;
		}
		table {
			border :				0px;
			border-spacing: 		0px;			
			text-align:				center;
		}
		a {
			color:					#".$persoCss['couleurEcriture'].";
			text-decoration: none;
		}";
		
	return $css;
}
?>