<?php
/* #############################################
	Fonctions d'Affichage
###############################################
Tous les calculs ont dj t fait avec les fonctions de calculs, donc aucune opration ne doit tre ralise ici.
Les fonctions d'affichages commencent toutes par 'html' et il n'y a qu'une qui a le droit de faire un echo
 Un fonction d'affichage ne peut lancer que des fonctions d'affichage.
###############################################
Les fonctions prsentent dans ce fichier sont :
htmlEcrire
htmlPage
htmlMenuVertical
htmlDeveloppeArbo
htmlImage
htmlMenuHorizontal
htmlImages
############################################# */



/* #############################################
	htmlEcrire
###############################################
htmlEcrire est une fonction qui prend le code html cr en paramtre.
Elle rajoute une l'entete html et le pied de page html.
Ensuite elle affiche le code entier de la page. 
Le but est d'avoir un seul echo dans tout le fichier.
############################################# */
function htmlEcrire($html, $meta, $css) {
	$entete = "
<html>
<head>
	<TITLE>Zphotos - ".$meta['titre']."</TITLE>
	<!-- Meta -->
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">
	<meta http-equiv=\"reply-to\" content=\"".$meta['courriel']."\">
	<meta name=\"Description\" content=\"".$meta['description']."\">
	<meta name=\"Keywords\" content=\"".$meta['mots-cles']."\">
	<meta name=\"Author\" content=\"Thomas ZILLIOX\">
	<meta name=\"Publisher\" content=\"www.zilliox.info\">
	<meta name=\"Copyright\" content=\"www.zilliox.info\">
	<meta name=\"Content-language\" content=\"".$meta['langue']."\">		
	<!-- CSS -->
	<style type=\"text/css\" media=\"screen\">
		body {
			margin : 0 0 0 0;
			padding : 0 0 0 0;
		}".
		$css."
	</style>
</head>
<body>";
	$pied = "
</body>
</html>";

	echo $entete.$html.$pied;
}



/* #############################################
	htmlPage
###############################################
htmlPage rassemble l'entete, le menu et les images ensemble.
############################################# */
function htmlPage($htmlImages, $htmlMenu, $htmlEntete) {
	$html = "
		<div id=\"entete\">".
			$htmlEntete."
		</div>
		<div id=\"menu\">".
			$htmlMenu."
		</div>
		<div id=\"images\">".
			$htmlImages."
		</div>";

	// Affichage des crdits
	$html .= "
		<div id=\"credits\">
				Zphotos Express V 1.0 -- <a href=\"http://zphotos.zilliox.info/ZphotosExpressV1.zip\">Tlchargez ce script gratuitement</a>.
		</div>";		
	
	return $html;
}



/* #############################################
	htmlMenuVertical
###############################################
htmlMenuVertical cre le menu de navigation entre les dossiers
Elle prend en paramtre : l'arborescence des dossiers ainsi que le menu actif.
Elle utilise htmlDeveloppeArbo.
############################################# */
function htmlMenuVertical($arbo, $menuActif) {
	$html = "
					<table>";
	
	$html .= htmlDeveloppeArbo(0, $arbo, $menuActif);
	$html .= "
				</table>";		
	
	return $html;
}



/* #############################################
	htmlDeveloppeArbo
###############################################
htmlDeveloppeArbo est une fonction rcursive qui cre le menu Vertical
############################################# */
function htmlDeveloppeArbo($niveau, $arbo, $menuActif) {
	$html = "";
	for($i=0; $i<count($arbo['nom']); $i++) {
		$html .= "
				<tr>
					<td class=\"dossier\">";
		for ($j=0; $j<$niveau; $j++) $html .= "&nbsp;&nbsp;&nbsp;&nbsp;";
		if (strcmp($arbo['nom'][$i],$menuActif) == 0) {
			$html .= "<b>".$arbo['nom'][$i]."</b>";
		} else {
			$html .= "<a href=\"index.php?url=".$arbo['lien'][$i]."\">".$arbo['nom'][$i]."</a>";
		}
		$html .= "	</td>
				</tr>";
		if ($arbo['fils'][$i]['nom']) $html .= htmlDeveloppeArbo($niveau+1, $arbo['fils'][$i], $menuActif);
	}
	
	return $html;
}



/* #############################################
	htmlImage
###############################################
 htmlImage est une fonction qui prend en paramtre :
l'adresse de l'image, la largeur et la hauteur d'affichage
Elle renvoit l'html correspondant  l'image
############################################# */
function htmlImage($imageSource, $largeur, $hauteur) {
	$html = "<img src=\"".$imageSource."\" width=\"".$largeur."\" height=\"".$hauteur."\">";

	return $html;
}



/* #############################################
	htmlMenuHorizontal
###############################################
htmlMenuHorizontal cre le menu de navigation pour tourner les pages d'un album
############################################# */
function htmlMenuHorizontal($affichage, $url) {
	$html = "
<div id=\"menuHorizontal\">";
	
	// Cration du bouton 'page prcdente'
	if ($affichage['page'] > 1) {
		$html .= "
			<a href=\"?url=".$url."&page=".($affichage['page']-1)."\"><<</a>";
	}
	
	// Cration du bouton 'numro de page
	for ($page = 1; $page <= $affichage['nbPage']; $page++) {
		if ( $page == $affichage['page']) {
			$html .= " <b>".$page."</b> ";
		} else {
			$html .= "
			<a href=\"?url=".$url."&page=".$page."\">".$page."</a>";
		}
	}
	
	// Cration du bouton 'page suivante'
	if ($affichage['page'] < $affichage['nbPage']) {
		$html .= "
			<a href=\"?url=".$url."&page=".($affichage['page']+1)."\">>></a>";
	}
	$html .= "
		 </div>";

	return $html;
}



/* #############################################
	htmlImages
###############################################
htmlImages cre le tableau qui va contenir ls photos affiches.
Elle contient encore quelques get... =(
############################################# */
function htmlImages($affichage, $urlt, $url, $perso) {
	$numImage = 0;
	$html = "
<table class=\"images\">";

	// Boucles du tableau
	for( $numLigne = 0; $numLigne < $affichage['nbLignesAAfficher']; $numLigne++) {
		$html .= "
	<tr>";
		for($numColonne = 0; $numColonne < $perso['nbColonnes']; $numColonne++) {
			if ($numImage < $affichage['nbImagesAAfficher']) {
				$imageSource = $urlt.$affichage['images'][$numImage];
				$html .= "
			<td bgcolor=\"#FFFFFF\">
				<a href=\"#\" onclick=\"javascript:window.open('index.php?zoom=".$imageSource."','ZOOM','width=".getLargeurImageReelle($imageSource).",height=".getHauteurImageReelle($imageSource)."');\" title=\"Cliquez pour agrandir l'image\">".htmlImage($imageSource, getLargeurImageReduite($imageSource, $perso), getHauteurImageReduite($imageSource, $perso))."</a>
			</td>";
				$numImage++;
			} // Fin 'if' encore des images  afficher
		} // Fin Boucle sur 'numColonne' 
		$html .= "
	</tr>";		
	} // Fin Boucle sur 'numLigne' 
	
	$html .= "
			</table>
		</td>
	</tr>
</table>";
	
	$html .= htmlMenuHorizontal($affichage, $url);

	return $html;
}
?>